/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	net_device.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-08-05
	*
	*	汾 		V1.2
	*
	*	˵ 		豸Ӧò
	*
	*	޸ļ¼	V1.11.ƽ̨IPPORTͨķʽȷ˲ͬЭ豸ͨõ⡣
	*					  2.ȡֶ磬ϵȴwifiģԶӣɹʹOneNETںŽ
	*					  3.NET_DEVICE_SendCmdmodeǷķֵ
	*				V1.21.ȡV1.1еĹ3
	*					  2.ݻȡӿڣrbơ
	*					  3.ȡ͸ģʽ
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//豸
#include "net_device.h"
#include "net_io.h"

//Ӳ
#include "delay.h"
#include "usart.h"

#if(NET_TIME_EN == 1)
#include "clock.h"
#endif

//C
#include <string.h>
#include <stdlib.h>
#include <stdio.h>


NET_DEVICE_INFO netDeviceInfo = {0, 0, 0, NULL, NULL, NULL, NULL, NULL, 0, {0}, 0, 0, 0, 0, 0, 0, 0};


GPS_INFO gps;


//==========================================================
//	ƣ	NET_DEVICE_IO_Init
//
//	ܣ	ʼ豸IO
//
//	ڲ	
//
//	ز	
//
//	˵		ʼ豸Ŀšշܵ
//==========================================================
void NET_DEVICE_IO_Init(void)
{

	GPIO_InitTypeDef gpioInitStruct;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOC, ENABLE);

	//M5310λ
	gpioInitStruct.GPIO_Mode = GPIO_Mode_Out_PP;
	gpioInitStruct.GPIO_Pin = GPIO_Pin_0;					//GPIOA0-λ
	gpioInitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &gpioInitStruct);
	
	gpioInitStruct.GPIO_Pin = GPIO_Pin_4;					//GPIOC4-Դ
	GPIO_Init(GPIOC, &gpioInitStruct);
	
	gpioInitStruct.GPIO_Mode = GPIO_Mode_IPU;
	gpioInitStruct.GPIO_Pin = GPIO_Pin_5;		
	GPIO_Init(GPIOC, &gpioInitStruct);						//GPIOC5-RING
	
	NET_DEVICE_PWR_ON;
	
	NET_IO_Init();											//豸IOʼ
	
	netDeviceInfo.reboot = 0;

}

//==========================================================
//	ƣ	NET_DEVICE_GetCsq
//
//	ܣ	ȡźǿ
//
//	ڲ	
//
//	ز	źǿֵ
//
//	˵		
//==========================================================
unsigned char NET_DEVICE_GetCsq(void)
{
	
	char *dataPtr = NULL;
	char num[4] = {0, 0, 0, 0}, count = 0;
	unsigned char csq = 0;

	if(!NET_DEVICE_SendCmd("AT+CSQ\r\n", "OK"))
	{
		//RSSI:0~31ԽԽǿ99
		dataPtr = strchr(netDeviceInfo.cmd_resp, ':');
		if(dataPtr != NULL)
		{
			dataPtr++;
			if(*dataPtr == ' ')
				dataPtr++;
			
			while(*dataPtr >= '0' && *dataPtr <= '9')
				num[count++] = *dataPtr++;
			
			csq = atoi(num);
			
			UsartPrintf(USART_DEBUG, "CSQ: %d\r\n", csq);
		}
		else
			UsartPrintf(USART_DEBUG, "%s\r\n", netDeviceInfo.cmd_resp);
	}
	
	return csq;

}

//==========================================================
//	ƣ	NET_DEVICE_Exist
//
//	ܣ	豸ڼ
//
//	ڲ	
//
//	ز	ؽ
//
//	˵		0-ɹ		1-ʧ
//==========================================================
_Bool NET_DEVICE_Exist(void)
{
	
	_Bool result = 1;

	if(!NET_DEVICE_SendCmd("AT\r\n", "OK"))
		result = 0;
	else
		result = 1;
	
	return result;

}

//==========================================================
//	ƣ	NET_DEVICE_Init
//
//	ܣ	豸ʼ
//
//	ڲ	protocolЭ(οNET_DEVICE_GetLinkIP˵)
//				ipIPַָ
//				port˿ڻָ
//
//	ز	سʼ
//
//	˵		0-ɹ		1-ʧ
//==========================================================
_Bool NET_DEVICE_Init(unsigned char protocol, char *ip, char *port)
{
	
	char *dataPtr = NULL;
	_Bool status = 1;
	
	netDeviceInfo.netWork = 0;

	switch(netDeviceInfo.initStep)
	{
		case 0:
		
			if(!NET_DEVICE_SendCmd("AT+MIPLVER?\r\n", "OK"))
			{
				UsartPrintf(USART_DEBUG, "%s\r\n", netDeviceInfo.cmd_resp);
				netDeviceInfo.initStep++;
			}
		
		break;
		
		case 1:
		
			UsartPrintf(USART_DEBUG, "AT+COPS=1,2,\"46000\"\r\n");
			if(!NET_DEVICE_SendCmd("AT+COPS=1,2,\"46000\"\r\n", "OK"))
				netDeviceInfo.initStep++;
		
		break;
			
		case 2:
		
			UsartPrintf(USART_DEBUG, "AT+CSCON=1\r\n");
			if(!NET_DEVICE_SendCmd("AT+CSCON=1\r\n", "OK"))
				netDeviceInfo.initStep++;
		
		break;
			
		case 3:
		
			if(!NET_DEVICE_SendCmd("AT+CIMI\r\n", "OK"))
			{
				UsartPrintf(USART_DEBUG, "IMSI: %s\r\n", netDeviceInfo.cmd_resp);
				netDeviceInfo.initStep++;
			}
		
		break;
			
		case 4:
		
			if(!NET_DEVICE_SendCmd("AT+CGSN=1\r\n", "OK"))
			{
				UsartPrintf(USART_DEBUG, "IMEI: %s\r\n", netDeviceInfo.cmd_resp);
				netDeviceInfo.initStep++;
			}
		
		break;
			
		case 5:
			
			netDeviceInfo.csq = NET_DEVICE_GetCsq();
			if(netDeviceInfo.csq > 3 && netDeviceInfo.csq < 32)
				netDeviceInfo.initStep++;
			else
				RTOS_TimeDly(200);
		
		break;
			
		case 6:
		
			UsartPrintf(USART_DEBUG, "AT+CEREG=1\r\n");
			if(!NET_DEVICE_SendCmd("AT+CEREG=1\r\n", "OK"))
				netDeviceInfo.initStep++;
		
		break;
			
		case 7:
		
			UsartPrintf(USART_DEBUG, "AT+CEREG?\r\n");
			if(!NET_DEVICE_SendCmd("AT+CEREG?\r\n", "+CEREG:1,1"))
				netDeviceInfo.initStep++;
		
		break;
			
		case 8:
		
			UsartPrintf(USART_DEBUG, "AT+NSOCR=DGRAM,17,4587,1\r\n");
			if(!NET_DEVICE_SendCmd("AT+NSOCR=DGRAM,17,4587,1\r\n", "OK"))
			{
				dataPtr = netDeviceInfo.cmd_resp;
				if(dataPtr != NULL)
				{
					while(*dataPtr < '0' || *dataPtr > '9')
						dataPtr++;
					
					netDeviceInfo.socket_id = *dataPtr - '0';
					UsartPrintf(USART_DEBUG, "socket_id: %d\r\n", netDeviceInfo.socket_id);
					netDeviceInfo.initStep++;
				}
				else
					UsartPrintf(USART_DEBUG, "%s\r\n", netDeviceInfo.cmd_resp);
			}
		
		break;
		
		default:
			
			status = 0;
			netDeviceInfo.netWork = 1;
			UsartPrintf(USART_DEBUG, "Tips:	M5310 OK\r\n");
		
		break;
	}
	
	return status;

}

//==========================================================
//	ƣ	NET_DEVICE_Reset
//
//	ܣ	豸λ
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
void NET_DEVICE_Reset(void)
{

	UsartPrintf(USART_DEBUG, "Tips:	M5310_Reset\r\n");
	
	NET_DEVICE_RST_ON;		//λ
	RTOS_TimeDly(50);
	
	NET_DEVICE_RST_OFF;		//λ
	RTOS_TimeDly(200);

}

//==========================================================
//	ƣ	NET_DEVICE_Close
//
//	ܣ	ر
//
//	ڲ	
//
//	ز	0-ɹ	1-ʧ
//
//	˵		
//==========================================================
_Bool NET_DEVICE_Close(void)
{
	
	char cmd_buf[16];
	_Bool result = 1;
	
	UsartPrintf(USART_DEBUG, "Tips:	CLOSE\r\n");

	snprintf(cmd_buf, sizeof(cmd_buf), "AT+SOCL=%d\r\n", netDeviceInfo.socket_id);
	if(!NET_DEVICE_SendCmd(cmd_buf, "OK"))
		result = 0;
	else
		result = 1;
	
	RTOS_TimeDly(10);
	
	return result;

}

//==========================================================
//	ƣ	NET_DEVICE_ReLink
//
//	ܣ	ƽ̨
//
//	ڲ	ipIPַָ
//				port˿ڻָ
//
//	ز	ӽ
//
//	˵		0-ɹ		1-ʧ
//==========================================================
_Bool NET_DEVICE_ReLink(char *ip, char *port)
{
	
	_Bool status = 1;
	char *dataPtr = NULL;
	
	NET_DEVICE_Close();

	UsartPrintf(USART_DEBUG, "AT+NSOCR=DGRAM,17,4587,1\r\n");
	if(!NET_DEVICE_SendCmd("AT+NSOCR=DGRAM,17,4587,1\r\n", "OK"))
	{
		dataPtr = netDeviceInfo.cmd_resp;
		if(dataPtr != NULL)
		{
			while(*dataPtr < '0' || *dataPtr > '9')
				dataPtr++;
			
			netDeviceInfo.socket_id = *dataPtr - '0';
			UsartPrintf(USART_DEBUG, "socket_id: %d\r\n", netDeviceInfo.socket_id);
			status = 0;
		}
		else
			UsartPrintf(USART_DEBUG, "%s\r\n", netDeviceInfo.cmd_resp);
	}
	
	return status;

}

//==========================================================
//	ƣ	NET_DEVICE_CmdHandle
//
//	ܣ	Ƿȷ
//
//	ڲ	cmdҪ͵
//
//	ز	
//
//	˵		ɹָNULL
//==========================================================
void NET_DEVICE_CmdHandle(char *cmd)
{
	
	if(strstr(cmd, netDeviceInfo.cmd_hdl) != NULL)
		netDeviceInfo.cmd_hdl = NULL;
	
	netDeviceInfo.cmd_resp = cmd;

}

//==========================================================
//	ƣ	NET_DEVICE_SendCmd
//
//	ܣ	豸һȴȷӦ
//
//	ڲ	cmdҪ͵
//				resҪӦ
//
//	ز	ӽ
//
//	˵		0-ɹ		1-ʧ
//==========================================================
_Bool NET_DEVICE_SendCmd(char *cmd, char *res)
{
	
	unsigned char timeOut = 200;
	
	NET_IO_Send((unsigned char *)cmd, strlen(cmd));			//д豸
	
	if(res == NULL)											//ΪգֻǷ
		return 0;
	
	netDeviceInfo.cmd_hdl = res;							//ҪѵĹؼ
	
	while((netDeviceInfo.cmd_hdl != NULL) && --timeOut)		//ȴ
		RTOS_TimeDly(2);
	
	if(timeOut > 0)
		return 0;
	else
		return 1;

}

//==========================================================
//	ƣ	HexString_2_Num
//
//	ܣ	ʮַתΪֵ
//
//	ڲ	hsʮַ
//
//	ز	ת
//
//	˵		Ҫ0xǰ׺
//==========================================================
int HexString_2_Num(char *hs)
{

	int num = 0;
	unsigned char len = 0, i = 0;
	
	if(hs == NULL)
		return -1;
	
	while(hs[i++] != '\0')
		len++;
	
	for(i = 0; i < len; i++)
	{
		if(hs[i] >= 'A' && hs[i] <= 'F')
			num |= (hs[i] - '7') << ((len - i - 1) << 2);
		else if(hs[i] >= 'a' && hs[i] <= 'f')
			num |= (hs[i] - 'W') << ((len - i - 1) << 2);
		else if(hs[i] >= '0' && hs[i] <= '9')
			num |= (hs[i] - '0') << ((len - i - 1) << 2);
		else
			return -2;
	}
	
	return num;

}

//==========================================================
//	ƣ	Num_2_HexString
//
//	ܣ	ֵתΪʮַ
//
//	ڲ	numֵ
//				hsַ
//				flag1-תΪд		0-תΪСд
//
//	ز	ַ	С0ʧ
//
//	˵		
//==========================================================
int Num_2_HexString(unsigned int num, char *hs, _Bool flag)
{

	unsigned char len = 0, i = 0;
	short n_temp = 0;
	
	if(num == 0)
	{
		hs[0] = '0';
		return 1;
	}
	
	while(1)					//תжٸַ
	{
		if(num >> (len << 2))
			len++;
		else
			break;
	}
	
	for(; i < len; i++)
	{
		n_temp = (short)((num >> (i << 2)) & 0xf);
		
		if(n_temp >= 0 && n_temp <= 9)
			hs[len - i - 1] = n_temp + '0';
		else if(n_temp >= 10 && n_temp <= 16)
			hs[len - i - 1] = n_temp + (flag ? '7' : 'W');
		else
		{
			for(i = 0; i < len; i++)
				hs[i] = 0;
			
			return -1;
		}
	}
	
	return len;

}

//==========================================================
//	ƣ	NET_DEVICE_SendData
//
//	ܣ	ʹ豸ݵƽ̨
//
//	ڲ	dataҪ͵
//				lenݳ
//
//	ز	
//
//	˵		
//==========================================================
void NET_DEVICE_SendData(unsigned char *data, unsigned short len)
{
	
	char cmdBuf[40];
	
	unsigned short i = 0, len_2 = len << 1;
	
	unsigned char *dataPtr = (unsigned char *)NET_MallocBuffer(len_2);
	
	if(dataPtr != NULL)
	{
		//RTOS_TimeDly(10);								//ȴһ
		
		for(i = 0; i < len_2; i++)
			dataPtr[i] = 0;
		
		for(i = 0; i < len; i++)
		{
			if(data[i] > 0x0f)
			{
				//sprintf((char *)dataPtr + (i << 1), "%X", data[i]);
				
				Num_2_HexString(data[i], (char *)dataPtr + (i << 1), 1);
			}
			else
			{
				//sprintf((char *)dataPtr + (i << 1), "0%X", data[i]);
				
				*(dataPtr + (i << 1)) = '0';
				Num_2_HexString(data[i], (char *)dataPtr + (i << 1) + 1, 1);
			}
		}
		
		snprintf(cmdBuf, sizeof(cmdBuf), "AT+NSOST=%d,183.230.40.40,5683,%d,", netDeviceInfo.socket_id, len);
		
		NET_IO_Send((unsigned char *)cmdBuf, strlen(cmdBuf));
		NET_IO_Send(dataPtr, len_2);
		NET_IO_Send("\r\n", 2);
		
		UsartPrintf(USART_DEBUG, "NET_DEVICE_SendData\r\n");
//		Usart_SendString(USART_DEBUG, (unsigned char *)cmdBuf, strlen(cmdBuf));
//		Usart_SendString(USART_DEBUG, dataPtr, len_2);
//		Usart_SendString(USART_DEBUG, "\r\n", 2);
		
		NET_FreeBuffer(dataPtr);
		
		//RTOS_TimeDly(10);								//ȴһ
	}

}

//==========================================================
//	ƣ	NET_DEVICE_WriteReadLen
//
//	ܣ	дݳ
//
//	ڲ	len
//
//	ز	0-ɹ	1-ʧ
//
//	˵		
//==========================================================
_Bool NET_DEVICE_WriteReadLen(unsigned short len)
{
	
	unsigned char count = 0;
	
	//ҵδݵĵط
	for(; count < sizeof(netDeviceInfo.remain_len); count++)
	{
		if(netDeviceInfo.remain_len[count] == 0)
		{
			netDeviceInfo.remain_len[count] = len;
			
			UsartPrintf(USART_DEBUG, "%s----%d\r\n", __FUNCTION__, len);
			
			return 0;
		}
	}
	
	return 1;

}

//==========================================================
//	ƣ	NET_DEVICE_GetReadLen
//
//	ܣ	ȡݳ
//
//	ڲ	
//
//	ز	ȡݳ
//
//	˵		
//==========================================================
unsigned short NET_DEVICE_GetReadLen(void)
{

	unsigned char i = 0, sizeof_len = 0;
	
	unsigned short read_len = netDeviceInfo.remain_len[0];
	
	if(read_len == 0)
		return read_len;
	
	UsartPrintf(USART_DEBUG, "%s----%d\r\n", __FUNCTION__, read_len);
	
	sizeof_len = sizeof(netDeviceInfo.remain_len) >> 1;
	for(; i < sizeof_len - 1; i++)
	{
		netDeviceInfo.remain_len[i] = netDeviceInfo.remain_len[i + 1];
		netDeviceInfo.remain_len[i + 1] = 0;
	}

	return read_len;

}

//==========================================================
//	ƣ	NET_DEVICE_Read
//
//	ܣ	ȡһ֡
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
unsigned char *NET_DEVICE_Read(void)
{

	return NET_IO_Read();

}

//==========================================================
//	ƣ	NET_DEVICE_GetIPD
//
//	ܣ	ȡƽ̨ص
//
//	ڲ	dataPtrԭʼָ
//
//	ز	ƽ̨صԭʼ
//
//	˵		ͬ豸صĸʽͬҪȥ
//				ESP8266ķظʽΪ	"+IPD,x:yyy"	xݳȣyyy
//==========================================================
unsigned char *NET_DEVICE_GetIPD(unsigned char *dataPtr)
{
	
	char *dataPtr_tp = (char *)dataPtr;
	
	if(dataPtr_tp != NULL)
	{
		dataPtr_tp = strstr(dataPtr_tp, "+NSONMI");					//NSONMIͷ
		if(dataPtr_tp == NULL)										//ûҵIPDͷӳ٣Ҫȴһᣬᳬ趨ʱ
		{
			//UsartPrintf(USART_DEBUG, "\"IPD\" not found\r\n");
		}
		else
		{
			char num_buf[4] = {0, 0, 0, 0};
			unsigned short i = 0;
			
			dataPtr_tp = strchr(dataPtr_tp, ',');					//ҵ','
			if(dataPtr_tp != NULL)
			{
				while(*dataPtr_tp < '0' || *dataPtr_tp > '9')
					dataPtr_tp++;
				
				while(*dataPtr_tp >= '0' && *dataPtr_tp <= '9')
					num_buf[i++] = *dataPtr_tp++;
				
				i = atoi(num_buf);
				
				NET_DEVICE_WriteReadLen(i);
				
				return "NSONMI";
			}
		}
	}

	return NULL;													//ʱδҵؿָ

}

//==========================================================
//	ƣ	NET_DEVICE_Check
//
//	ܣ	豸״̬
//
//	ڲ	
//
//	ز	״̬
//
//	˵		
//==========================================================
unsigned char NET_DEVICE_Check(void)
{

	return 0;

}

//==========================================================
//	ƣ	NET_DEVICE_ReConfig
//
//	ܣ	豸豸ʼĲ
//
//	ڲ	ֵ
//
//	ز	
//
//	˵		úõĲ豸ʼõ
//==========================================================
void NET_DEVICE_ReConfig(unsigned char step)
{

	netDeviceInfo.initStep = step;

}

/******************************************************************************************
										Ϣ
******************************************************************************************/

//==========================================================
//	ƣ	NET_DEVICE_CheckListHead
//
//	ܣ	鷢ͷǷΪ
//
//	ڲ	
//
//	ز	0-	1-Ϊ
//
//	˵		
//==========================================================
_Bool NET_DEVICE_CheckListHead(void)
{

	if(netDeviceInfo.head == NULL)
		return 0;
	else
		return 1;

}

//==========================================================
//	ƣ	NET_DEVICE_GetListHeadBuf
//
//	ܣ	ȡҪ͵ָ
//
//	ڲ	
//
//	ز	ȡҪ͵ָ
//
//	˵		
//==========================================================
unsigned char *NET_DEVICE_GetListHeadBuf(void)
{

	return netDeviceInfo.head->buf;

}

//==========================================================
//	ƣ	NET_DEVICE_GetListHeadLen
//
//	ܣ	ȡҪ͵ݳ
//
//	ڲ	
//
//	ز	ȡҪ͵ݳ
//
//	˵		
//==========================================================
unsigned short NET_DEVICE_GetListHeadLen(void)
{

	return netDeviceInfo.head->dataLen;

}

//==========================================================
//	ƣ	NET_DEVICE_AddDataSendList
//
//	ܣ	ڷβһ
//
//	ڲ	bufҪ͵
//				dataLenݳ
//
//	ز	0-ɹ	-ʧ
//
//	˵		첽ͷʽ
//==========================================================
unsigned char NET_DEVICE_AddDataSendList(unsigned char *buf ,unsigned short dataLen)
{
	
	struct NET_SEND_LIST *current = (struct NET_SEND_LIST *)NET_MallocBuffer(sizeof(struct NET_SEND_LIST));
																//ڴ
	
	if(current == NULL)
		return 1;
	
	current->buf = (unsigned char *)NET_MallocBuffer(dataLen);	//ڴ
	if(current->buf == NULL)
	{
		NET_FreeBuffer(current);								//ʧͷ
		return 2;
	}
	
	if(netDeviceInfo.head == NULL)								//headΪNULL
		netDeviceInfo.head = current;							//headָǰڴ
	else														//headΪNULL
		netDeviceInfo.end->next = current;							//endָǰڴ
	
	memcpy(current->buf, buf, dataLen);							//
	current->dataLen = dataLen;
	current->next = NULL;										//һΪNULL
	
	netDeviceInfo.end = current;								//endָǰڴ
	
	return 0;

}

//==========================================================
//	ƣ	NET_DEVICE_DeleteDataSendList
//
//	ܣ	ͷɾһ
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
_Bool NET_DEVICE_DeleteDataSendList(void)
{
	
	struct NET_SEND_LIST *next = netDeviceInfo.head->next;	//ͷһݵַ
	
	netDeviceInfo.head->dataLen = 0;
	netDeviceInfo.head->next = NULL;
	NET_FreeBuffer(netDeviceInfo.head->buf);				//ͷڴ
	NET_FreeBuffer(netDeviceInfo.head);						//ͷڴ
	
	netDeviceInfo.head = next;								//ͷָһ
	
	return 0;

}
