#ifndef _NET_DEVICE_H_
#define _NET_DEVICE_H_


//===========================================================
//===========ṩRTOSڴҲʹC=========
#include "FreeRTOS.h"

#define NET_MallocBuffer	pvPortMalloc

#define NET_FreeBuffer		vPortFree
//==========================================================


struct NET_SEND_LIST
{

	unsigned short dataLen;			//ݳ
	unsigned char *buf;				//ָ
	
	struct NET_SEND_LIST *next;		//һ

};


typedef struct
{
	
	unsigned int net_time;
	unsigned char csq;
	
	unsigned char socket_id;
	
	char *cmd_resp;					//ظָ롣ȡصݣȡָڵ
	char *cmd_ipd;					//ڽonenetǰͨȡݣʱ䡢ȡip
	char *cmd_hdl;					//ڷ󣬻ڷûָķ
	
/*************************Ͷ*************************/
	struct NET_SEND_LIST *head, *end;
	
	_Bool read_real_data;
	unsigned short remain_len[8];	//ʣδȡ
	
	unsigned short err : 4; 		//
	unsigned short initStep : 4;	//ʼ
	unsigned short dataType : 4;	//趨ݷ--16
	unsigned short reboot : 1;		//־
	unsigned short netWork : 1;		//OK
	unsigned short NET_DEVICE_OK : 1;
	unsigned short reverse : 1;		//Ԥ

} NET_DEVICE_INFO;

extern NET_DEVICE_INFO netDeviceInfo;


typedef struct
{

	char lon[16];
	char lat[16];
	
	_Bool flag;

} GPS_INFO;

extern GPS_INFO gps;


#define NET_DEVICE_RST_ON		GPIO_SetBits(GPIOA, GPIO_Pin_0)
#define NET_DEVICE_RST_OFF		GPIO_ResetBits(GPIOA, GPIO_Pin_0)

#define NET_DEVICE_PWR_ON		GPIO_ResetBits(GPIOC, GPIO_Pin_4)
#define NET_DEVICE_PWR_OFF		GPIO_SetBits(GPIOC, GPIO_Pin_4)

#define PHONE_AP_MODE			0	//1-ʹֻȵģʽΧ·ʱAirKiss޷ʹãʹù̶ʽ
									//0-ʹAirKissķʽ

#define NET_TIME_EN				0	//1-ȡʱ		0-ȡ

#define DEV_OK					1
#define DEV_ERR					0


void NET_DEVICE_IO_Init(void);

_Bool NET_DEVICE_Exist(void);

_Bool NET_DEVICE_Init(unsigned char protocol, char *ip, char *port);

void NET_DEVICE_Reset(void);

_Bool NET_DEVICE_Close(void);

_Bool NET_DEVICE_ReLink(char *ip, char *port);

void NET_DEVICE_CmdHandle(char *cmd);

_Bool NET_DEVICE_SendCmd(char *cmd, char *res);

void NET_DEVICE_SendData(unsigned char *data, unsigned short len);

_Bool NET_DEVICE_WriteReadLen(unsigned short len);

unsigned short NET_DEVICE_GetReadLen(void);

unsigned char *NET_DEVICE_Read(void);

unsigned char *NET_DEVICE_GetIPD(unsigned char *dataPtr);

unsigned char NET_DEVICE_Check(void);

void NET_DEVICE_ReConfig(unsigned char step);

_Bool NET_DEVICE_CheckListHead(void);

unsigned char *NET_DEVICE_GetListHeadBuf(void);

unsigned short NET_DEVICE_GetListHeadLen(void);

unsigned char NET_DEVICE_AddDataSendList(unsigned char *buf ,unsigned short dataLen);

_Bool NET_DEVICE_DeleteDataSendList(void);


int HexString_2_Num(char *hs);

int Num_2_HexString(unsigned int num, char *hs, _Bool flag);

#endif
