/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	net_IO.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-08-05
	*
	*	汾 		V1.3
	*
	*	˵ 		豸IO
	*
	*	޸ļ¼	V1.1DMA͹
	*				V1.2DMAչܡIDLEж
	*				V1.3RingBuffer
	*						˵	rbд룺ڴڽѭд롣
	*								rbȡ˼һ֡
	*										βӽϲӦ
	*										øݽȡ
	*										ݡ
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//豸IO
#include "net_io.h"

//Ӳ
#include "delay.h"
#include "usart.h"


NET_IO_INFO net_io_info = {{0}, {0}, 0, 0, 0};


const unsigned char tag[] = {0, 127, 255};			//Զ
const unsigned char tag_num = sizeof(tag);


/*
************************************************************
*	ƣ	NET_IO_Init
*
*	ܣ	ʼ豸IO
*
*	ڲ	
*
*	ز	
*
*	˵		ײշ
************************************************************
*/
void NET_IO_Init(void)
{

	Usart2_Init(9600);
#if(USART_DMA_RX_EN == 1)
	USARTx_ResetMemoryBaseAddr(NET_IO, (unsigned int)net_io_info.buf, RB_BUFFER_SIZE, USART_RX_TYPE);
#endif

}

/*
************************************************************
*	ƣ	NET_IO_AddTag2End
*
*	ܣ	ÿһ֡ĩβԶĽ
*
*	ڲ	
*
*	ز	
*
*	˵		ӽԷϴһ֡
************************************************************
*/
void NET_IO_AddTag2End(void)
{

	unsigned char i = 0;
	
	for(; i < tag_num; i++)								//һ֡βӽ
	{
		net_io_info.buf[net_io_info.write_pos++] = tag[i];
		net_io_info.write_pos %= RB_BUFFER_SIZE;
	}
	
#if(USART_DMA_RX_EN == 1)
	DMA_Cmd(DMA1_Channel6, DISABLE);												//رDMA

	DMA_SetCurrDataCounter(DMA1_Channel6, RB_BUFFER_SIZE - net_io_info.write_pos);	//ʣֽ
	DMA1_Channel6->CMAR = (unsigned int)(net_io_info.buf + net_io_info.write_pos);	//õǰDMAָڴָ
	
	DMA_Cmd(DMA1_Channel6, ENABLE);													//ʹMDA
#endif
	
	net_io_info.data_packet++;							//ݰָ

}

/*
************************************************************
*	ƣ	NET_IO_CheckTag
*
*	ܣ	ȡһ֡ݴС
*
*	ڲ	
*
*	ز	
*
*	˵		ݽжһ֡ݵĳ
************************************************************
*/
unsigned short NET_IO_CheckTag(void)
{
	
	unsigned short bytes = 0, read_pos = net_io_info.read_pos;
	unsigned char i = 0;
	
	while(i < tag_num)											//δҵ
	{
		if(net_io_info.buf[read_pos] == tag[i])					//ҵ˵һ
			i++;												//
		else													//ͽƥ
		{
			i = 0;												//ͷ
			if(net_io_info.buf[read_pos] == tag[i])				//Ƚϵǰǲǵһ
				i++;
		}
		
		bytes++;
		read_pos++;
		
		bytes %= RB_BUFFER_SIZE;								//鷶Χ
		read_pos %= RB_BUFFER_SIZE;
	}

	return bytes;

}

/*
************************************************************
*	ƣ	NET_IO_Send
*
*	ܣ	
*
*	ڲ	strҪ͵
*				lenݳ
*
*	ز	
*
*	˵		ײݷ
*
************************************************************
*/
void NET_IO_Send(unsigned char *str, unsigned short len)
{
	
#if(USART_DMA_TX_EN == 0)
	unsigned short count = 0;
	
	for(; count < len; count++)
	{
		USART_SendData(NET_IO, *str++);									//
		while(USART_GetFlagStatus(NET_IO, USART_FLAG_TC) == RESET);		//ȴ
	}
#else
	unsigned int mAddr = (unsigned int)str;
	
	while(DMA_GetFlagStatus(DMA1_FLAG_TC7) == RESET);					//ȴͨ7
	DMA_ClearFlag(DMA1_FLAG_TC7);										//ͨ7ɱ־
	
	USARTx_ResetMemoryBaseAddr(NET_IO, mAddr, len, USART_TX_TYPE);
#endif

}

/*
************************************************************
*	ƣ	NET_IO_Read
*
*	ܣ	ȡյ
*
*	ڲ	
*
*	ز	ȡָ֡
*
*	˵		
************************************************************
*/
unsigned char *NET_IO_Read(void)
{
	
	unsigned short read_num = 0, i = 0;
	unsigned char *buf = NULL;
	
	if(net_io_info.data_packet > 0)													//ݰɶʱ
	{
		if(--net_io_info.data_packet == 65535)
			net_io_info.data_packet = 0;
		
		read_num = NET_IO_CheckTag();												//Ҫȡݳ
		
		if(net_io_info.write_pos <= net_io_info.read_pos)							//ݡѭһȦ*********************
		{
			if(net_io_info.read_pos + read_num < RB_BUFFER_SIZE)					//ǰ֡ݻδrb
			{
				buf = net_io_info.buf + net_io_info.read_pos;
			}
			else																	//ǰγrbβγrb
			{
				unsigned short num = RB_BUFFER_SIZE - net_io_info.read_pos;			//rbβҪݳ
				
				if(read_num >= RB_BUFFER2_SIZE)										//ڶ
					return NULL;
				
				for(i = 0; i < num; i++)											//rbβЧݵ
					net_io_info.buf_tp[i] = net_io_info.buf[i + net_io_info.read_pos];
				
				for(i = 0; i < read_num - num; i++)									//rb׵Чݵ
					net_io_info.buf_tp[i + num] = net_io_info.buf[i];
				
				buf = net_io_info.buf_tp;
			}
		}
		else																		//ݡһδѭһȦ*******************
		{
			buf = net_io_info.buf + net_io_info.read_pos;
		}
		
		net_io_info.read_pos += read_num;											//ƶָ
		net_io_info.read_pos %= RB_BUFFER_SIZE;										//ȷָ벻rbΧ
	}
	
	return buf;

}

/*
************************************************************
*	ƣ	DMA1_Channel6_IRQHandler
*
*	ܣ	DMA1_ͨ6_жϺ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void DMA1_Channel6_IRQHandler(void)
{

	if(DMA_GetITStatus(DMA1_IT_TC6) == SET)
	{

#if(USART_DMA_RX_EN == 1)
		net_io_info.write_pos = 0;
		USARTx_ResetMemoryBaseAddr(NET_IO, (unsigned int)net_io_info.buf, RB_BUFFER_SIZE, USART_RX_TYPE);
#endif
		DMA_ClearFlag(DMA1_IT_TC6);
	}

}

/*
************************************************************
*	ƣ	USART2_IRQHandler
*
*	ܣ	USART2ж
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void USART2_IRQHandler(void)
{
	
	RTOS_EnterInt();
	
#if(USART_DMA_RX_EN == 0)
	if(USART_GetFlagStatus(USART2, USART_FLAG_RXNE) != RESET)			//ж
	{
		USART_ClearFlag(USART2, USART_FLAG_RXNE);
		
		netIOInfo.buf[netIOInfo.write_pos++] = USART2->DR;				//дrb
		netIOInfo.write_pos %= RB_BUFFER_SIZE;							//rbΧ
	}
#endif
	
	if(USART_GetFlagStatus(USART2, USART_FLAG_IDLE) != RESET)			//ж
	{
		USART2->DR;														//ȡע⣺Ҫܹжϱ־λ
		USART_ClearFlag(USART2, USART_IT_IDLE);
		
#if(USART_DMA_RX_EN == 1)
		net_io_info.write_pos = RB_BUFFER_SIZE - DMA_GetCurrDataCounter(DMA1_Channel6);
#endif
		
		NET_IO_AddTag2End();											//յһ֡ݣβӽ
	}
	
	RTOS_ExitInt();

}
