/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	dStream.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-12-28
	*
	*	汾 		V1.0
	*
	*	˵ 		װ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Эװļ
#include "dStream.h"

//C
#include <string.h>
#include <stdio.h>


//==========================================================
//	ƣ	DSTREAM_toString
//
//	ܣ	ϢתΪM5310ĸʽ
//
//	ڲ	streamArrayṹ
//				buf
//				posڼ
//				bufLenС
//
//	ز	0-ɹ	1-ʧ
//
//	˵		
//==========================================================
_Bool DSTREAM_toString(DATA_STREAM *streamArray, char *buf, unsigned short pos, unsigned short bufLen)
{
	
	unsigned char dataType = 0;
	_Bool status = 0;
	
	if(streamArray[pos].dataType >= 7 && streamArray[pos].dataType <= 14)
		dataType = 3;
	else if(streamArray[pos].dataType == 15)
		dataType = 4;
	else if(streamArray[pos].dataType >= 1 && streamArray[pos].dataType <= 6)
		dataType = streamArray[pos].dataType;
	else
		return 1;
	
	if(streamArray[pos].flag)
	{
		switch((unsigned char)streamArray[pos].dataType)
		{
			case TYPE_STRING:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%s\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, (char *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_OPAQUE:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%s\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, (char *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_ULONG:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%d\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(unsigned int *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_LONG:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%ld\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(signed long *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_UINT:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%ld\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(unsigned long *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_INT:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%d\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(signed int *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_USHORT:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%d\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(unsigned short *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_SHORT:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%d\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(signed short *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_UCHAR:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%d\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(unsigned char *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_CHAR:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%d\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(signed char *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_FLOAT:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%f\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(float *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_DOUBLE:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%f\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(double *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_BOOL:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%d\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, *(_Bool *)streamArray[pos].dataPoint);
			
			break;
			
			case TYPE_HEXSTR:
			
				snprintf(buf, bufLen, "AT+MIPLNOTIFY=0,%s,%s,%s,%d,\"%s\",1\r\n",
										streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
										dataType, (char *)streamArray[pos].dataPoint);
			
			break;
			
			default:
				status = 1;
			break;
		}
	}
	else
		status = 1;
	
	return status;

}

//==========================================================
//	ƣ	DSTREAM_toString_ReadResp
//
//	ܣ	ϢתΪM5310ĸʽ
//
//	ڲ	streamArrayṹ
//				buf
//				posڼ
//				bufLenС
//
//	ز	0-ɹ	1-ʧ
//
//	˵		
//==========================================================
_Bool DSTREAM_toString_ReadResp(DATA_STREAM *streamArray, char *buf, unsigned short pos, unsigned short bufLen, char *msg_id)
{
	
	unsigned char dataType = 0;
	_Bool status = 0;
	
	if(streamArray[pos].dataType >= 7 && streamArray[pos].dataType <= 14)
		dataType = 3;
	else if(streamArray[pos].dataType == 15)
		dataType = 4;
	else if(streamArray[pos].dataType >= 1 && streamArray[pos].dataType <= 6)
		dataType = streamArray[pos].dataType;
	else
		return 1;

	switch((unsigned char)streamArray[pos].dataType)
	{
		case TYPE_STRING:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%s\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, (char *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_OPAQUE:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%s\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, (char *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_ULONG:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%d\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(unsigned int *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_LONG:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%ld\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(signed long *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_UINT:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%ld\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(unsigned long *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_INT:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%d\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(signed int *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_USHORT:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%d\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(unsigned short *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_SHORT:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%d\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(signed short *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_UCHAR:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%d\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(unsigned char *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_CHAR:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%d\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(signed char *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_FLOAT:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%f\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(float *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_DOUBLE:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%f\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(double *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_BOOL:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%d\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, *(_Bool *)streamArray[pos].dataPoint);
		
		break;
		
		case TYPE_HEXSTR:
		
			snprintf(buf, bufLen, "AT+MIPLREAD=0,%s,%s,%s,%s,%d,\"%s\",1\r\n",
									msg_id, streamArray[pos].obj_id, streamArray[pos].ins_id, streamArray[pos].res_id,
									dataType, (char *)streamArray[pos].dataPoint);
		
		break;
		
		default:
			status = 1;
		break;
	}
	
	if(streamArray[pos].flag == 0)
		status = 1;
	
	return status;

}
