/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	fault.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2016-11-23
	*
	*	汾 		V1.0
	*
	*	˵ 		
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭ
#include "mcu_gpio.h"

//Э
#include "onenet.h"
#include "fault.h"

//豸
#include "net_device.h"

//Ӳ
#include "usart.h"
#include "delay.h"


NET_FAULT_INFO net_fault_info;


//==========================================================
//	ƣ	Fault_Process
//
//	ܣ	
//
//	ڲ	
//
//	ز	
//
//	˵		
//==========================================================
void NET_Fault_Process(void)
{
	
	if(net_fault_info.net_fault_flag)
	{
		net_fault_info.net_fault_flag = 0;
		net_fault_info.net_fault_count++;
	}

	switch(net_fault_info.net_fault_level)
	{
		case NET_FAULT_LEVEL_0:
		
			UsartPrintf(USART_DEBUG, "WARN:	NET_FAULT_LEVEL_0\r\n");
		
		break;
		
		case NET_FAULT_LEVEL_1:											//ȼ1-IP
		
			UsartPrintf(USART_DEBUG, "WARN:	NET_FAULT_LEVEL_1\r\n");
		
			NET_DEVICE_ReConfig(5);
			
			net_device_info.net_work = 0;
			onenet_info.net_work = 0;
			
			if(++onenet_info.reinit_count >= 5)
			{
				onenet_info.reinit_count = 0;
				net_fault_info.net_fault_level = NET_FAULT_LEVEL_3;		//ȼ3
			}
			else
				net_fault_info.net_fault_level = NET_FAULT_LEVEL_0;		//ȼ
		
		break;
		
		case NET_FAULT_LEVEL_2:											//ȼ2-ע
		
			UsartPrintf(USART_DEBUG, "WARN:	NET_FAULT_LEVEL_2\r\n");
			
			net_device_info.device_ok = 0;
			net_device_info.net_work = 0;
			NET_DEVICE_ReConfig(0);
			
			net_device_info.net_work = 0;
			onenet_info.net_work = 0;
			
			net_fault_info.net_fault_level = NET_FAULT_LEVEL_0;			//ȼ
		
		break;
		
		case NET_FAULT_LEVEL_3:											//ȼ3-λ豸
		
			UsartPrintf(USART_DEBUG, "WARN:	NET_FAULT_LEVEL_3\r\n");
			
			NET_DEVICE_Reset();
			
			net_fault_info.net_fault_level = NET_FAULT_LEVEL_2;			//ȼ
		
		break;
		
		case NET_FAULT_LEVEL_4:											//ȼ4-豸ϵ
		
			UsartPrintf(USART_DEBUG, "WARN:	NET_FAULT_LEVEL_4\r\n");
		
			MCU_GPIO_Output_Ctl("nd_pwr", 1);
		
			RTOS_TimeDly(1200);
			
			MCU_GPIO_Output_Ctl("nd_pwr", 0);
		
			net_fault_info.net_fault_level = NET_FAULT_LEVEL_3;			//ȼ
		
		break;
		
		case NET_FAULT_LEVEL_5:
		
			UsartPrintf(USART_DEBUG, "WARN:	NET_FAULT_LEVEL_5\r\n");
		
			net_fault_info.net_fault_level = NET_FAULT_LEVEL_0;
		
		break;
		
		default:
		break;
	}

}
