/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	onenet.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-05-27
	*
	*	汾 		V1.0
	*
	*	˵ 		OneNETƽ̨Ӧʾ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//豸
#include "net_device.h"

//Эļ
#include "onenet.h"
#include "fault.h"
#include "nb_cmd.h"

//Ӳ
#include "usart.h"
#include "delay.h"
#include "led.h"

//C
#include <string.h>
#include <stdio.h>
#include <stdlib.h>


ONETNET_INFO onenet_info = {0, 0, 0, 1, 0, 0};


//==========================================================
//	ƣ	OneNet_SendData
//
//	ܣ	ϴݵƽ̨
//
//	ڲ	streamArrayṹ
//				streamArrayCntԱ
//
//	ز	SEND_TYPE_OK-ͳɹ	SEND_TYPE_DATA-Ҫ
//
//	˵		
//==========================================================
unsigned char OneNet_SendData(DATA_STREAM *streamArray, unsigned short streamArrayCnt)
{
	
	unsigned char i = 0, j = 0, err_count = 0;
	char data_buf[56];
	
	if(!onenet_info.net_work)
		return SEND_TYPE_DATA;
	
	if(net_device_info.busy)
		return SEND_TYPE_DATA;
	
	net_device_info.busy = 1;
	
	UsartPrintf(USART_DEBUG, "OneNet_SendData-Total-%d\r\n", streamArrayCnt);
	
	for(; i < streamArrayCnt;)
	{
		if(!DSTREAM_toString(streamArray, data_buf, i, sizeof(data_buf)))
		{
			j++;
			
			if(!NET_DEVICE_SendCmd(data_buf, "OK"))
				i++;
			else
			{
				if(++err_count >= 5)
				{
					err_count = 0;
					i++;
					net_device_info.send_count++;
				}
				
				RTOS_TimeDly(20);
			}
		}
		else
			i++;
	}
	
	if(j >= streamArrayCnt)
		net_device_info.send_count = 0;
	
	UsartPrintf(USART_DEBUG, "OneNet_SendData-Real-%d\r\n", j);
	
	net_device_info.busy = 0;
	
	return SEND_TYPE_OK;
	
}

_Bool OneNet_Update(unsigned int time)
{

	return NET_DEVICE_Update(time);

}

//==========================================================
//	ƣ	OneNET_CmdHandle
//
//	ܣ	ȡƽ̨rbе
//
//	ڲ	streamArrayṹ
//				streamArrayCntԱ
//
//	ز	
//
//	˵		
//==========================================================
void OneNET_CmdHandle(DATA_STREAM *streamArray, unsigned short streamArrayCnt)
{
	
	unsigned char *dataPtr = NULL;						//ָ

	dataPtr = NET_DEVICE_Read();						//ȴ
	
	if(dataPtr != NULL)									//Ч
	{
		//UsartPrintf(USART_DEBUG, "-----\r\nOneNET_CmdHandle:%s\r\n*****\r\n", dataPtr);
		if(strstr((char *)dataPtr, "+MIPLWRITE"))
		{
			char msg_id[8], obj_id[8], ins_id[8], res_id[8];
			char *msg = NULL;
			//+MIPLWRITE:0,42990,3201,0,5750,NB
			
			NB_CMD_UnPacketGeneralID(dataPtr, msg_id, obj_id, ins_id, res_id);
			
			if(NB_CMD_Unpacket_W_E_Msg(dataPtr, &msg) == 0)
			{
				UsartPrintf(USART_DEBUG, "Write:	msg_id:%s, obj_id:%s, ins_id:%s, res_id:%s, msg:%s\r\n", msg_id, obj_id, ins_id, res_id, msg);
				
				if(NB_CMD_Write(obj_id, ins_id, res_id, msg, streamArray, streamArrayCnt) == 0)
					NB_CMD_W_E_Resp(msg_id, 1, 1);
				else
					NB_CMD_W_E_Resp(msg_id, 0, 1);
				
				NET_FreeBuffer(msg);
			}
		}
		else if(strstr((char *)dataPtr, "+MIPLREAD"))
		{
			char msg_id[8], obj_id[8], ins_id[8], res_id[8];
			//+MIPLREAD:0,56303,3201,0,5750
			
			NB_CMD_UnPacketGeneralID(dataPtr, msg_id, obj_id, ins_id, res_id);
			
			UsartPrintf(USART_DEBUG, "Read:	msg_id:%s, obj_id:%s, ins_id:%s, res_id:%s\r\n", msg_id, obj_id, ins_id, res_id);
			
			NB_CMD_ReadResp(msg_id, obj_id, ins_id, res_id, streamArray, streamArrayCnt);
			
		}
		else if(strstr((char *)dataPtr, "+MIPLEXECUTE"))
		{
			char msg_id[8], obj_id[8], ins_id[8], res_id[8];
			char *msg = NULL;
			//+MIPLEXECUTE:0,10240,3202,0,5605,111
			
			NB_CMD_UnPacketGeneralID(dataPtr, msg_id, obj_id, ins_id, res_id);
			
			if(NB_CMD_Unpacket_W_E_Msg(dataPtr, &msg) == 0)
			{
				UsartPrintf(USART_DEBUG, "Execute:	msg_id:%s, obj_id:%s, ins_id:%s, res_id:%s, msg:%s\r\n", msg_id, obj_id, ins_id, res_id, msg);
				
				if(NB_CMD_Execute(obj_id, ins_id, res_id, msg, streamArray, streamArrayCnt) == 0)
					NB_CMD_W_E_Resp(msg_id, 1, 0);
				else
					NB_CMD_W_E_Resp(msg_id, 0, 0);
				
				NET_FreeBuffer(msg);
			}
		}
		else if(strstr((char *)dataPtr, "+MIPLCLOSE:0,1"))
		{
			UsartPrintf(USART_DEBUG, "WARN:	ӶϿ׼\r\n");
			
			net_fault_info.net_fault_level = NET_FAULT_LEVEL_1;			//ȼ1
		}
		else
			NET_DEVICE_CmdHandle((char *)dataPtr);
	}

}
