/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	adc.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-02-27
	*
	*	汾 		V1.0
	*
	*	˵ 		ADCʼ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭ
#include "mcu_adc.h"
#include "mcu_dma.h"

//Ӳ
#include "adc.h"

#if(ADC_DMA_EN == 0)
#include "delay.h"
#endif


/*****************************************************************************

ʹ˵
1.ݳ޸adc.h ADC_DMA_EN  ADC_CH_NUM 

2.޸ adc_channel_list ͨбҪɼͨ

*****************************************************************************/


unsigned short adc_value_list[ADC_CH_NUM];


//ע⣺ADCx_Init֮ǰдͨб!!!!!!!!!!!!!!!!!!!!!!!!!!!!
const unsigned char adc_channel_list[ADC_CH_NUM] = {ADC_Channel_10, ADC_Channel_16};


/*
************************************************************
*	ƣ	ADCx_Init
*
*	ܣ	ADCxʼ
*
*	ڲ	ADCxADC豸
*				temp_flag1-ڲ¶Ȳ	0-ڲ¶Ȳ
*
*	ز	
*
*	˵		ֻADC1ڲ¶Ȳ
*				ҪҪгʼӦGPIO
************************************************************
*/
void ADCx_Init(ADC_TypeDef *ADCx, _Bool temp_flag)
{
	
#if(ADC_DMA_EN == 1)
	if(ADCx == ADC1)
	{
		MCU_DMA_Init(DMA1, DMA1_Channel1, (unsigned int)&ADCx->DR, (unsigned int)adc_value_list, DMA_DIR_PeripheralSRC, ADC_CH_NUM,
					DMA_PeripheralInc_Disable, DMA_MemoryInc_Enable, DMA_PeripheralDataSize_HalfWord,
					DMA_MemoryDataSize_HalfWord, DMA_Mode_Circular, DMA_Priority_Medium, DMA_M2M_Disable);
		
		DMA_Cmd(DMA1_Channel1, ENABLE);											//ʹDMAͨ
	}
	else if(ADCx == ADC3)
	{
		MCU_DMA_Init(DMA2, DMA2_Channel5, (unsigned int)&ADCx->DR, (unsigned int)adc_value_list, DMA_DIR_PeripheralSRC, ADC_CH_NUM,
					DMA_PeripheralInc_Disable, DMA_MemoryInc_Enable, DMA_PeripheralDataSize_HalfWord,
					DMA_MemoryDataSize_HalfWord, DMA_Mode_Circular, DMA_Priority_Medium, DMA_M2M_Disable);
		
		DMA_Cmd(DMA2_Channel5, ENABLE);											//ʹDMAͨ
	}
#endif
	
	MCU_ADCx_Init(ADCx, RCC_PCLK2_Div6, ADC_Mode_Independent, ENABLE, ADC_ExternalTrigConv_None,
					ADC_DataAlign_Right, ADC_CH_NUM, adc_channel_list, temp_flag);
	
#if(ADC_DMA_EN == 1)
	ADC_DMACmd(ADCx, ENABLE);
	
	ADC_SoftwareStartConvCmd(ADCx, ENABLE);
#endif

}

/*
************************************************************
*	ƣ	ADCx_GetValue
*
*	ܣ	ȡһADCxֵ
*
*	ڲ	ADCxADC豸
*				chͨ
*
*	ز	ADCxת
*
*	˵		ADC_Channel_1~ADC_Channel_16
************************************************************
*/
unsigned short ADCx_GetValue(ADC_TypeDef *ADCx, unsigned char ch)
{

#if(ADC_DMA_EN == 1)
	unsigned char i = 0;
	
	while(ch != adc_channel_list[i])					//ҵҪȡͨ˳
	{
		if(++i >= ADC_CH_NUM)
			return 0;
	}
	
	if(ADCx == ADC1)
		while(!DMA_GetFlagStatus(DMA1_FLAG_TC1));		//ȴDMA
	else if(ADCx == ADC3)
		while(!DMA_GetFlagStatus(DMA2_FLAG_TC5));		//ȴDMA
	
	return adc_value_list[i];							//ͨ
#else
	ADC_SoftwareStartConvCmd(ADCx, ENABLE);				//ʹָADC1ת
	 
	while(!ADC_GetFlagStatus(ADCx, ADC_FLAG_EOC));		//ȴת

	return ADC_GetConversionValue(ADCx);				//һADC1ת
#endif

}

/*
************************************************************
*	ƣ	ADCx_GetValueTimes
*
*	ܣ	ȡADCxֵƽֵ
*
*	ڲ	ADCxADC豸
*				chͨ
*				times
*
*	ز	ѹƽֵ
*
*	˵		ADC_Channel_1~ADC_Channel_16
************************************************************
*/
unsigned short ADCx_GetValueTimes(ADC_TypeDef *ADCx, unsigned char ch, unsigned char times)
{

	float adcValue = 0;
	unsigned char i = 0;
	
	for(; i < times; i++)
	{
		adcValue += (float)ADCx_GetValue(ADCx, ch);
#if(ADC_DMA_EN == 0)
		DelayXms(5);
#endif
	}
	
	return (unsigned short)(adcValue / times);

}

/*
************************************************************
*	ƣ	ADCx_GetVoltag
*
*	ܣ	ȡADCxĵѹֵ
*
*	ڲ	ADCxADC豸
*				chͨ
*				times
*
*	ز	ѹֵ
*
*	˵		ADC_Channel_1~ADC_Channel_16
************************************************************
*/
float ADCx_GetVoltag(ADC_TypeDef *ADCx, unsigned char ch, unsigned char times)
{

	unsigned short voltag = ADCx_GetValueTimes(ADCx, ch, times);
	
	return (float)voltag / 4096 * 3.3;

}

/*
************************************************************
*	ƣ	ADC1_GetTemperature
*
*	ܣ	ȡADCͨڲ¶ֵ
*
*	ڲ	
*
*	ز	¶ֵ
*
*	˵		
************************************************************
*/
float ADC1_GetTemperature(void)
{

	float temp = ADCx_GetValueTimes(ADC1, ADC_Channel_16, 10);	//ȡԭʼAD
	
	temp = temp * 3.3 / 4096;									//תΪѹֵ
	
	return (1.43 - temp) / 0.0043 + 25;							//ǰ¶ֵ

}
