/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	hwtimer.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-02-27
	*
	*	汾 		V1.0
	*
	*	˵ 		Ƭʱʼ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭ
#include "mcu_timer.h"
#include "mcu_nvic.h"
#include "mcu_gpio.h"

//Ӳ
#include "hwtimer.h"


/*
************************************************************
*	ƣ	Timer1_8_PWM_Init
*
*	ܣ	Timer18PWM
*
*	ڲ	TIMxTIM1  TIM8
*				pscƵֵ
*				arrֵ
*
*	ز	
*
*	˵		
************************************************************
*/
void Timer1_8_PWM_Init(TIM_TypeDef *TIMx, GPIO_TypeDef *gpio_group, unsigned short gpio_pin, unsigned short psc, unsigned short arr)
{
	
	MCU_GPIO_Init(gpio_group, gpio_pin, GPIO_Mode_AF_PP, GPIO_Speed_50MHz, (void *)0);
	
	MCU_TIMER_Base_Init(TIMx, TIM_CKD_DIV1, TIM_CounterMode_Up, arr, psc, 0);
	
	MCU_Timer_PWM_Init(TIMx, TPC_4, TIM_OCMode_PWM1, TIM_OutputState_Enable, 0, 0, TIM_OCPolarity_Low, 0, 0, 0);
	
	TIM_Cmd(TIMx, ENABLE);										//ʹTIMx

}

/*
************************************************************
*	ƣ	TIM3_PWM_Init
*
*	ܣ	Timer3_PWM
*
*	ڲ	pscƵֵ
*				arrֵ
*
*	ز	
*
*	˵		
************************************************************
*/
void TIM3_PWM_Init(GPIO_TypeDef *gpio_group, unsigned short gpio_pin, unsigned short psc, unsigned short arr)
{
	
	MCU_GPIO_Init(gpio_group, gpio_pin, GPIO_Mode_AF_PP, GPIO_Speed_50MHz, (void *)0);
	
	MCU_TIMER_Base_Init(TIM3, TIM_CKD_DIV1, TIM_CounterMode_Up, arr, psc, 0);
	
	MCU_Timer_PWM_Init(TIM3, TPC_4, TIM_OCMode_PWM2, TIM_OutputState_Enable, 0, 0, TIM_OCPolarity_Low, 0, 0, 0);
	
	TIM_Cmd(TIM3, ENABLE);										//ʹTIM3

}

/*
************************************************************
*	ƣ	Timer6_7_Init
*
*	ܣ	Timer67Ķʱ
*
*	ڲ	TIMxTIM6  TIM7
*				pscƵֵ
*				arrֵ
*
*	ز	
*
*	˵		timer6timer7ֻижϹ
************************************************************
*/
void Timer6_7_Init(TIM_TypeDef *TIMx, unsigned short psc, unsigned short arr)
{
	
	MCU_TIMER_Base_Init(TIMx, 0, TIM_CounterMode_Up, arr, psc, 0);
	
	if(TIMx == TIM6)
		MCU_NVIC_Init(TIM6_IRQn, ENABLE, 1, 1);
	else
		MCU_NVIC_Init(TIM7_IRQn, ENABLE, 1, 1);
	
	TIM_ITConfig(TIMx, TIM_IT_Update, ENABLE);					//ʹܸж
	
	TIM_Cmd(TIMx, ENABLE); 										//ʹܶʱ

}

/*
************************************************************
*	ƣ	TIM6_IRQHandler
*
*	ܣ	RTOSʱж
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void TIM6_IRQHandler(void)
{

	if(TIM_GetITStatus(TIM6, TIM_IT_Update) == SET)
	{
		TIM_ClearITPendingBit(TIM6, TIM_IT_Update);
	}

}

/*
************************************************************
*	ƣ	TIM7_IRQHandler
*
*	ܣ	Timer7жϷ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void TIM7_IRQHandler(void)
{

	if(TIM_GetITStatus(TIM7, TIM_IT_Update) == SET)
	{
		TIM_ClearITPendingBit(TIM7, TIM_IT_Update);
	}

}
