/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	rtc.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-11-09
	*
	*	汾 		V1.1
	*
	*	˵ 		RTCʼ͹
	*
	*	޸ļ¼	V1.1޸RTCʹõBUG
						  RTCжϿƹ
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//Ƭ
#include "mcu_nvic.h"

//Ӳ
#include "delay.h"
#include "rtc.h"


RTC_INFO rtc_info;



/*
************************************************************
*	ƣ	RTC_Init
*
*	ܣ	RTCʼ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
_Bool RTC_Init(void)
{
	
#if(USE_EXT_RCC == 1)
	unsigned char err_count = 0;
#endif

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);	//ʹPWRBKPʱ   
	PWR_BackupAccessCmd(ENABLE);												//ʹܺ󱸼Ĵ
	
	BKP_DeInit();																//λ
#if(USE_EXT_RCC == 1)
	RCC_LSEConfig(RCC_LSE_ON);													//ⲿپ(LSE),ʹپ
	
	while(RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET && err_count < 250)		//ָRCC־λ,ȴپ
	{
		err_count++;
		DelayXms(10);
	}
	
	if(err_count >= 250)
		return 1;																//ʼʱʧ,
#endif
	
#if(USE_EXT_RCC == 1)
	RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);										//RTCʱ(RTCCLK),ѡLSEΪRTCʱ
#else
	RCC_RTCCLKConfig(RCC_RTCCLKSource_HSE_Div128);								//RTCʱ(HSE/128),ѡHESΪRTCʱ
#endif
	RCC_RTCCLKCmd(ENABLE);														//ʹRTCʱ
	RTC_WaitForLastTask();														//ȴһζRTCĴд
	RTC_WaitForSynchro();														//ȴRTCĴͬ
	
	RTC_ITConfig(RTC_IT_ALR, ENABLE);											//ʹRTCж
	RTC_WaitForLastTask();														//ȴһζRTCĴд
	
	RTC_EnterConfigMode();														//
#if(USE_EXT_RCC == 1)
	RTC_SetPrescaler(32767);													//RTCԤƵֵ
#else
	RTC_SetPrescaler(HSE_VALUE / 128 - 1);										//RTCԤƵֵ
#endif
	RTC_WaitForLastTask();														//ȴһζRTCĴд
	
	RTC_SetCounter(0);															//RTCֵ
	RTC_WaitForLastTask();														//ȴһζRTCĴд
	
	RTC_ExitConfigMode();														//˳ģʽ
	
	RTC_NVIC_Init();
	
	return 0;

}

/*
************************************************************
*	ƣ	RTC_NVIC_Init
*
*	ܣ	RTCжϳʼ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void RTC_NVIC_Init(void)
{
	
#if(RTC_ALRE_INT_EN == 1)
	EXTI_InitTypeDef exti_initstruct;
#endif
	
#if(RTC_SEC_INT_EN == 1)
	RTC_ITConfig(RTC_IT_SEC, ENABLE);
#endif
	
#if(RTC_OW_INT_EN == 1)
	RTC_ITConfig(RTC_IT_OW, ENABLE);
#endif
	
#if(RTC_ALR_INT_EN == 1)
	RTC_ITConfig(RTC_IT_ALR, ENABLE);
#endif
	
#if(RTC_SEC_INT_EN == 1 || RTC_OW_INT_EN == 1 || RTC_ALR_INT_EN == 1)
	MCU_NVIC_Init(RTC_IRQn, ENABLE, 2, 1);
#endif
	
#if(RTC_ALRE_INT_EN == 1)
	RTC_ITConfig(RTC_IT_SEC, ENABLE);

	//ֹͣģʽRTCⲿж17Ͽɻ
	exti_initstruct.EXTI_Line = EXTI_Line17;
	exti_initstruct.EXTI_LineCmd = ENABLE;
	exti_initstruct.EXTI_Mode = EXTI_Mode_Interrupt;
	exti_initstruct.EXTI_Trigger = EXTI_Trigger_Rising;	//
	
	EXTI_Init(&exti_initstruct);
	
	MCU_NVIC_Init(RTCAlarm_IRQn, ENABLE, 2, 0);
#endif

}

/*
************************************************************
*	ƣ	RTC_SetTime
*
*	ܣ	RTCʱ
*
*	ڲ	secֵ
*
*	ز	
*
*	˵		
************************************************************
*/
void RTC_SetTime(unsigned int sec)
{

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);	//ʹPWRBKPʱ  
	PWR_BackupAccessCmd(ENABLE);												//ʹRTCͺ󱸼Ĵ 
	RTC_SetCounter(sec);														//RTCֵ

	RTC_WaitForLastTask();														//ȴһζRTCĴд

}

/*
************************************************************
*	ƣ	RTC_AlarmSet
*
*	ܣ	RTCӳʼ
*
*	ڲ	secֵ
*
*	ز	
*
*	˵		дһ32bitʱ䡣RTC_CNTʱж
************************************************************
*/
void RTC_AlarmSet(unsigned int sec)
{

	RTC_WaitForLastTask();
	
	RTC_SetAlarm(RTC_GetCounter() + sec);	//ڵǰʱ
	
	RTC_WaitForLastTask();
	RTC_WaitForSynchro();					//ȴRTCĴͬ

}

/*
************************************************************
*	ƣ	RTC_IRQHandler
*
*	ܣ	RTCһ㹦ж
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void RTC_IRQHandler(void)
{

	//ж
	if(RTC_GetITStatus(RTC_IT_SEC))
	{
		RTC_ClearITPendingBit(RTC_IT_SEC);	//ж
		
		rtc_info.rtc_sec_int = 1;
	}
	//ж
	if(RTC_GetITStatus(RTC_IT_OW))
	{
		RTC_ClearITPendingBit(RTC_IT_OW);	//ж
		
		rtc_info.rtc_ow_int = 1;
	}
	//ж
	if(RTC_GetITStatus(RTC_IT_ALR))
	{
		RTC_ClearITPendingBit(RTC_IT_ALR);	//ж
		
		rtc_info.rtc_alr_int = 1;
	}

}

/*
************************************************************
*	ƣ	RTCAlarm_IRQHandler
*
*	ܣ	RTC-ⲿж
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void RTCAlarm_IRQHandler(void)
{
	
	rtc_info.rtc_alre_int = 1;
	
	EXTI_ClearITPendingBit(EXTI_Line17);

}
