/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	stmflash.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-11-23
	*
	*	汾 		V1.0
	*
	*	˵ 		STM32F1xxƬƬflash
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//Ӳ
#include "stmflash.h"


#define STM32F1_FLASH_BASE		0x08000000	//STM32 FLASHʼַ
#define STM32F1_2048_BYTE		2048		//ҳƫ
#define STM32F1_1024_BYTE		1024		//ҳƫ


/*
************************************************************
*	ƣ	FLASH_GetStartAddr
*
*	ܣ	ҳȡַ
*
*	ڲ	pageַ(2ı)
*				flash_typeflashͣ0-1KB	1-2KB
*
*	ز	
*
*	˵		
************************************************************
*/
unsigned int FLASH_GetStartAddr(unsigned char page, _Bool flash_type)
{
	
	if(flash_type)
		return ((unsigned int)page * STM32F1_2048_BYTE) + STM32F1_FLASH_BASE;
	else
		return ((unsigned int)page * STM32F1_1024_BYTE) + STM32F1_FLASH_BASE;

}

/*
************************************************************
*	ƣ	FLASH_Erase
*
*	ܣ	STM32F10xƬڲFlash
*
*	ڲ	pageҪʼҳ(0~255)
*				numҪҳ
*				flash_typeflashͣ0-1KB	1-2KB
*
*	ز	
*
*	˵		1.STM32F10xƬڲFlashʼַ0x0800 0000
				2.СÿҳΪ1KBֱ32ҳ64ҳ128ҳ
				3.ÿҳ2KB256ҳ
				4.ÿҳ2KB128ҳ
				5.һҳʱԼ3~4us
************************************************************
*/
void FLASH_Erase(unsigned char page, unsigned char num, _Bool flash_type)
{
	
	unsigned int addr = FLASH_GetStartAddr(page, flash_type);
	unsigned char i = 0;
	
	FLASH_Unlock();														//

	if(flash_type)
	{
		for(; i < num;)
		{
			if(FLASH_ErasePage(addr) == FLASH_COMPLETE)
			{
				i++;
				addr += STM32F1_2048_BYTE;
			}
		}
	}
	else
	{
		for(; i < num;)
		{
			if(FLASH_ErasePage(addr) == FLASH_COMPLETE)
			{
				i++;
				addr += STM32F1_1024_BYTE;
			}
		}
	}
	
	FLASH_Lock();														//

}

/*
************************************************************
*	ƣ	Flash_Read
*
*	ܣ	STM32F10xƬڲFlashȡ
*
*	ڲ	pageҪʼҳ(0~255)
*				rBuf()
*				lenȡĳ
*				flash_typeflashͣ0-1KB	1-2KB
*
*	ز	
*
*	˵		
************************************************************
*/
void Flash_Read(unsigned char page, unsigned short *rBuf, unsigned short len, _Bool flash_type)
{

	unsigned short lenCount = 0;
	unsigned int addr = FLASH_GetStartAddr(page, flash_type);
	
	for(; lenCount < len; lenCount++)
	{
		rBuf[lenCount] = *(volatile unsigned short *)addr;
		
		addr += 2;											//ĵַ2ı
	}

}

/*
************************************************************
*	ƣ	Flash_Write
*
*	ܣ	STM32F10xƬڲFlashд
*
*	ڲ	addrַ(2ı)
*				wBuf()
*				lenдĳ
*				flash_typeflashͣ0-1KB	1-2KB
*
*	ز	
*
*	˵		дȽϸӵ㣬ע㣺
*					1.
*					2.ֻеַߵֵΪ0xFFFFʱܹд
*					3.д
************************************************************
*/
void Flash_Write(unsigned char page, unsigned short *wBuf, unsigned short len, _Bool flash_type)
{
	
	unsigned short lenCount = 0;
	
	unsigned int addr = FLASH_GetStartAddr(page, flash_type);
	
	FLASH_Unlock();														//
	
	for(; lenCount < len; lenCount++)
	{
		FLASH_ProgramHalfWord(addr, wBuf[lenCount]);					//д

		addr += 2;														//ַ2ı
	}
	
	FLASH_Lock();														//

}

