/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	mcu_spi.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2018-02-26
	*
	*	汾 		V1.0
	*
	*	˵ 		ƬSPI
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭ
#include "mcu_rcc.h"
#include "mcu_gpio.h"
#include "mcu_spi.h"


/*
************************************************************
*	ƣ	MCU_SPIx_Init
*
*	ܣ	ƬSPIʼ
*
*	ڲ	SPI_GroupSPI
*				SPI_Direction䷽
*				SPI_Modeģʽ
*				SPI_DataSizeݿ
*				SPI_CPOLʱӵ̬
*				SPI_CPHAݲʱ
*				SPI_NSSNSSźӲNSSܽţʹSSIλ
*				SPI_BaudRatePrescalerԤƵֵ
*				SPI_FirstBitݴMSBλLSBλʼ
*				SPI_CRCPolynomialCRCֵĶʽ
*
*	ز	0-ɹ	1-ʧ
*
*	˵		
************************************************************
*/
_Bool MCU_SPIx_Init(SPI_TypeDef *SPI_Group, unsigned short SPI_Direction, unsigned short SPI_Mode, unsigned short SPI_DataSize,
					unsigned short SPI_CPOL, unsigned short SPI_CPHA, unsigned short SPI_NSS, unsigned short SPI_BaudRatePrescaler,
					unsigned short SPI_FirstBit, unsigned short SPI_CRCPolynomial)
{
	
	_Bool result = 1;
	SPI_InitTypeDef spi_initstruct;

	MCU_RCC(SPI_Group, ENABLE);
	
	if(SPI_Group == SPI1)
	{
		MCU_GPIO_Init(GPIOA, GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7, GPIO_Mode_AF_PP, GPIO_Speed_50MHz, (void *)0);
		
		GPIO_SetBits(GPIOA, GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7);
		
		result = 0;
	}
	else if(SPI_Group == SPI2)
	{
		MCU_GPIO_Init(GPIOB, GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15, GPIO_Mode_AF_PP, GPIO_Speed_50MHz, (void *)0);
		
		GPIO_SetBits(GPIOB, GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15);
		
		result = 0;
	}
	else if(SPI_Group == SPI3)
	{
		MCU_GPIO_SWJ_JTAGDisable();
		
		MCU_GPIO_Init(GPIOB, GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5, GPIO_Mode_AF_PP, GPIO_Speed_50MHz, (void *)0);
		
		GPIO_SetBits(GPIOB, GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5);
		
		result = 0;
	}
	
	if(result == 0)
	{
		spi_initstruct.SPI_Direction = SPI_Direction;					//SPI˫ģʽ
		spi_initstruct.SPI_Mode = SPI_Mode;								//SPIģʽ
		spi_initstruct.SPI_DataSize = SPI_DataSize;						//SPIݴС
		spi_initstruct.SPI_CPOL = SPI_CPOL;								//ôʱӵ̬
		spi_initstruct.SPI_CPHA = SPI_CPHA;								//ݲʱ
		spi_initstruct.SPI_NSS = SPI_NSS;								//NSSźӲNSSܽţʹSSIλ
		spi_initstruct.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler;	//岨ԤƵֵ
		spi_initstruct.SPI_FirstBit = SPI_FirstBit;						//ָݴMSBλLSBλʼ
		spi_initstruct.SPI_CRCPolynomial = SPI_CRCPolynomial;			//CRCֵĶʽ
		
		SPI_Init(SPI_Group, &spi_initstruct);							//ʼ
	}
	
	return result;

}

/*
************************************************************
*	ƣ	MCU_SPIx_TX_Init
*
*	ܣ	ƬSPI_TXʼ
*
*	ڲ	SPI_GroupSPI
*				SPI_Direction䷽
*				SPI_Modeģʽ
*				SPI_DataSizeݿ
*				SPI_CPOLʱӵ̬
*				SPI_CPHAݲʱ
*				SPI_NSSNSSźӲNSSܽţʹSSIλ
*				SPI_BaudRatePrescalerԤƵֵ
*				SPI_FirstBitݴMSBλLSBλʼ
*				SPI_CRCPolynomialCRCֵĶʽ
*
*	ز	0-ɹ	1-ʧ
*
*	˵		
************************************************************
*/
_Bool MCU_SPIx_TX_Init(SPI_TypeDef *SPI_Group, unsigned short SPI_Direction, unsigned short SPI_Mode, unsigned short SPI_DataSize,
					unsigned short SPI_CPOL, unsigned short SPI_CPHA, unsigned short SPI_NSS, unsigned short SPI_BaudRatePrescaler,
					unsigned short SPI_FirstBit, unsigned short SPI_CRCPolynomial)
{
	
	_Bool result = 1;
	SPI_InitTypeDef spi_initstruct;

	MCU_RCC(SPI_Group, ENABLE);
	
	if(SPI_Group == SPI1)
	{
		MCU_GPIO_Init(GPIOA, GPIO_Pin_5 | GPIO_Pin_7, GPIO_Mode_AF_PP, GPIO_Speed_50MHz, (void *)0);
		
		GPIO_SetBits(GPIOA, GPIO_Pin_5 | GPIO_Pin_7);
		
		result = 0;
	}
	else if(SPI_Group == SPI2)
	{
		MCU_GPIO_Init(GPIOB, GPIO_Pin_13 | GPIO_Pin_15, GPIO_Mode_AF_PP, GPIO_Speed_50MHz, (void *)0);
		
		GPIO_SetBits(GPIOB, GPIO_Pin_13 | GPIO_Pin_15);
		
		result = 0;
	}
	else if(SPI_Group == SPI3)
	{
		MCU_GPIO_Init(GPIOB, GPIO_Pin_3 | GPIO_Pin_5, GPIO_Mode_AF_PP, GPIO_Speed_50MHz, (void *)0);
		
		GPIO_SetBits(GPIOB, GPIO_Pin_3 | GPIO_Pin_5);
		
		result = 0;
	}
	
	if(result == 0)
	{
		spi_initstruct.SPI_Direction = SPI_Direction;					//SPI˫ģʽ
		spi_initstruct.SPI_Mode = SPI_Mode;								//SPIģʽ
		spi_initstruct.SPI_DataSize = SPI_DataSize;						//SPIݴС
		spi_initstruct.SPI_CPOL = SPI_CPOL;								//ôʱӵ̬
		spi_initstruct.SPI_CPHA = SPI_CPHA;								//ݲʱ
		spi_initstruct.SPI_NSS = SPI_NSS;								//NSSźӲNSSܽţʹSSIλ
		spi_initstruct.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler;	//岨ԤƵֵ
		spi_initstruct.SPI_FirstBit = SPI_FirstBit;						//ָݴMSBλLSBλʼ
		spi_initstruct.SPI_CRCPolynomial = SPI_CRCPolynomial;			//CRCֵĶʽ
		
		SPI_Init(SPI_Group, &spi_initstruct);							//ʼ
	}
	
	return result;

}
