/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	freertosAPI.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-01-24
	*
	*	汾 		V1.0
	*
	*	˵ 		FreeRTOSṩһЩѯķװ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

#include "freertosAPI.h"

#include "usart.h"






/*
************************************************************
*	ƣ	FreeRTOS_GetFreeHeapSize
*
*	ܣ	ѯOSڴʣ
*
*	ڲ	
*
*	ز	ʣֽ
*
*	˵		
************************************************************
*/
size_t FreeRTOS_GetFreeHeapSize(void)
{

	size_t freeSize = 0;
	
	freeSize = xPortGetFreeHeapSize();
	UsartPrintf(USART_DEBUG, "freeSize = %dByte(s)\r\n", freeSize);			//ʣڴС
	
	return freeSize;

}

/*
************************************************************
*	ƣ	FreeRTOS_GetMinimumEverFreeHeapSize
*
*	ܣ	ϵ翪ʼѯOSڴʣСֵ
*
*	ڲ	
*
*	ز	ʣֽ
*
*	˵		
************************************************************
*/
size_t FreeRTOS_GetMinimumEverFreeHeapSize(void)
{

	size_t freeSize = 0;
	
	freeSize = xPortGetMinimumEverFreeHeapSize();
	UsartPrintf(USART_DEBUG, "freeMiniSize = %d\r\n", freeSize);		//ջʷСʣС
	
	return freeSize;

}

/*
************************************************************
*	ƣ	FreeRTOS_GetNumberOfTasks
*
*	ܣ	ȡǰڵ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
UBaseType_t FreeRTOS_GetNumberOfTasks(void)
{
	
	UBaseType_t taskNum = uxTaskGetNumberOfTasks();
	
	UsartPrintf(USART_DEBUG, "Task Number = %d\r\n", taskNum);		//(+timer)

	return taskNum;

}

/*
************************************************************
*	ƣ	FreeRTOS_GetTaskInfo
*
*	ܣ	ѯĳľϢ
*
*	ڲ	pcNameToQuery
*
*	ز	
*
*	˵		ʹҪСջ
************************************************************
*/
void FreeRTOS_GetTaskInfo(const char *pcNameToQuery)
{
	
#if(INCLUDE_xTaskGetHandle == 1)
	
	TaskHandle_t TaskHandle;
	TaskStatus_t TaskStatus;
	
	//ʹ		#define	INCLUDE_xTaskGetHandle					1
	TaskHandle = xTaskGetHandle(pcNameToQuery);												//ȡ
	
	//ȡLED0_TaskϢ
	vTaskGetInfo((TaskHandle_t	)TaskHandle,												//
				 (TaskStatus_t*	)&TaskStatus,												//Ϣṹ
				 (BaseType_t	)pdTRUE,													//ͳջʷСʣС
				 (eTaskState	)eInvalid);													//Լȡ׳̬
	
	//ͨڴӡָйϢ
	UsartPrintf(USART_DEBUG, ":                %s\r\n", TaskStatus.pcTaskName);
	UsartPrintf(USART_DEBUG, ":              %d\r\n", (int)TaskStatus.xTaskNumber);
	UsartPrintf(USART_DEBUG, "׳̬:              %d\r\n", TaskStatus.eCurrentState);
	UsartPrintf(USART_DEBUG, "ǰȼ:        %d\r\n", (int)TaskStatus.uxCurrentPriority);
	UsartPrintf(USART_DEBUG, "ȼ:          %d\r\n", (int)TaskStatus.uxBasePriority);
	UsartPrintf(USART_DEBUG, "ջַ:        %#x\r\n", (int)TaskStatus.pxStackBase);
	UsartPrintf(USART_DEBUG, "ջʷʣСֵ:%d\r\n", TaskStatus.usStackHighWaterMark);
	
#else
	
	UsartPrintf(USART_DEBUG, "FreeRTOSConfig.h  Add \"#define	INCLUDE_xTaskGetHandle  1\"\r\n");
	
#endif

}

/*
************************************************************
*	ƣ	FreeRTOS_GetAllTasksInfo
*
*	ܣ	ѯļϢ
*
*	ڲ	
*
*	ز	
*
*	˵		
************************************************************
*/
void FreeRTOS_GetAllTasksInfo(void)
{

#if ( ( configUSE_TRACE_FACILITY == 1 ) && ( configUSE_STATS_FORMATTING_FUNCTIONS > 0 ) )
	
	char InfoBuffer[512];
	
	vTaskList(InfoBuffer);								//ȡϢ
	UsartPrintf(USART_DEBUG, "%s\r\n", InfoBuffer);
	
#else
	
	UsartPrintf(USART_DEBUG, "FreeRTOSConfig.h  Add \"#define	configUSE_TRACE_FACILITY  1 and configUSE_STATS_FORMATTING_FUNCTIONS > 0\"\r\n");
	
#endif

}
