/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	main.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2017-01-23
	*
	*	汾 		V1.0
	*
	*	˵ 		ɵƬʼICʼĴ
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭͷļ
#include "stm32f10x.h"

//OS
#include "FreeRTOS.h"
#include "task.h"
#include "timers.h"
#include "freertosAPI.h"

//豸
#include "net_device.h"

//Э
#include "onenet.h"
#include "fault.h"

//дִĻص
#include "nb_callback.h"

//Ӳ
#include "delay.h"
#include "usart.h"
#include "iwdg.h"
#include "led.h"

//C
#include <string.h>
#include <time.h>
#include <stdio.h>


//Ź
#define IWDG_TASK_PRIO		9
#define IWDG_STK_SIZE		64
TaskHandle_t IWDG_Task_Handler;
void IWDG_Task(void *pvParameters);

//
#define USART_TASK_PRIO		8
#define USART_STK_SIZE		256
TaskHandle_t USART_Task_Handler;
void USART_Task(void *pvParameters);

//ݷ
#define SEND_TASK_PRIO		7
#define SEND_STK_SIZE		64
TaskHandle_t SEND_Task_Handler;
void SEND_Task(void *pvParameters);

//
#define SENSOR_TASK_PRIO	6
#define SENSOR_STK_SIZE		256
TaskHandle_t SENSOR_Task_Handler;
void SENSOR_Task(void *pvParameters);

//ݷ
#define DATA_TASK_PRIO		5 //
#define DATA_STK_SIZE		256
TaskHandle_t DATA_Task_Handler;
void DATA_Task(void *pvParameters);

//ά
#define UPDATE_TASK_PRIO	4
#define UPDATE_STK_SIZE		128
TaskHandle_t UPDATE_Task_Handler;
void UPDATE_Task(void *pvParameters);

//ϴ
#define FAULT_TASK_PRIO		3 //
#define FAULT_STK_SIZE		128
TaskHandle_t FAULT_Task_Handler;
void FAULT_Task(void *pvParameters);

//ʼ
#define NET_TASK_PRIO		2 //
#define NET_STK_SIZE		256
TaskHandle_t NET_Task_Handler;
void NET_Task(void *pvParameters);


#define NET_COUNT		5		//

#define NET_TIME		75		//趨ʱ--λ

unsigned short timer_count = 0;	//ʱ--λ


TimerHandle_t t1_Thdl;			//ʱ


//
DATA_STREAM data_stream[] = {
								{"3200", "0", "5502", &led_status.led_status[0], TYPE_BOOL, 1, CALLBACK_LED1, NULL},	//RW-led
								{"3200", "1", "5502", &led_status.led_status[1], TYPE_BOOL, 1, CALLBACK_LED2, NULL},	//RW-led
								{"3200", "2", "5502", &led_status.led_status[2], TYPE_BOOL, 1, CALLBACK_LED3, NULL},	//RW-led
								{"3200", "3", "5502", &led_status.led_status[3], TYPE_BOOL, 1, CALLBACK_LED4, NULL},	//RW-led
								
								{"3200", "0", "5501", &net_device_info.signal, TYPE_CHAR, 1, NULL, NULL},				//R-signal
								{"3200", "1", "5501", &net_fault_info.net_fault_count, TYPE_USHORT, 1, NULL, NULL},		//R-Ϣ
								
							};
unsigned char data_stream_cnt = sizeof(data_stream) / sizeof(data_stream[0]);


/*
************************************************************
*	ƣ	Hardware_Init
*
*	ܣ	Ӳʼ
*
*	ڲ	
*
*	ز	
*
*	˵		ʼƬԼ豸
************************************************************
*/
void Hardware_Init(void)
{
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);								//жϿ

	Delay_Init();																//Timer4ʼ
	
	Usart1_Init(115200); 														//ʼ   115200bps
#if(USART_DMA_RX_EN)
	USARTx_ResetMemoryBaseAddr(USART_DEBUG, (unsigned int)alter_info.alter_buf, sizeof(alter_info.alter_buf), USART_RX_TYPE);
#endif
	
	LED_Init();																	//LEDʼ

	if(RCC_GetFlagStatus(RCC_FLAG_IWDGRST) == SET) 								//ǿŹλʾ
	{
		UsartPrintf(USART_DEBUG, "WARN:	IWDG Reboot\r\n");
		
		RCC_ClearFlag();														//Źλ־λ
		
		net_fault_info.net_fault_level = net_fault_info.net_fault_level_r
														= NET_FAULT_LEVEL_5;	//ȼ5
		
		net_device_info.reboot = 1;
	}
	else
	{
		UsartPrintf(USART_DEBUG, "1.ssid_pswd in ROM\r\n");
		
		UsartPrintf(USART_DEBUG, "2.endpoint_name: %s\r\n", EP_NAME);
		
		net_device_info.reboot = 0;
	}
	
	Iwdg_Init(4, 1250); 														//64Ƶÿ625Σ1250Σ2s
	
	UsartPrintf(USART_DEBUG, "3.Hardware init OK\r\n");							//ʾʼ

}

/*
************************************************************
*	ƣ	OS_TimerCallBack
*
*	ܣ	ʱ״̬־λ
*
*	ڲ	ʱ
*
*	ز	
*
*	˵		ʱ񡣶ʱ״̬趨ʱӣƽ̨
************************************************************
*/
void OS_TimerCallBack(TimerHandle_t xTimer)
{
	
	if(onenet_info.net_work == 0)										//ڹ涨ʱ绹δɹ
	{
		if(++timer_count >= NET_TIME) 									//Ͽʱ
		{
			UsartPrintf(USART_DEBUG, "Tips:	Timer Check Err\r\n");
			
			timer_count = 0;
			
			net_fault_info.net_fault_level = NET_FAULT_LEVEL_3;			//ȼ3
		}
	}
	else
	{
		timer_count = 0;												//
		
		if(net_device_info.send_count >= NET_COUNT)						//ʹﵽNET_COUNT
		{
			UsartPrintf(USART_DEBUG, "Tips:	Timer Check Err-Send\r\n");
		
			net_device_info.send_count = 0;
			
			net_fault_info.net_fault_level = NET_FAULT_LEVEL_1;			//ȼ1
		}
	}

}

/*
************************************************************
*	ƣ	main
*
*	ܣ	ɳʼ񣬴Ӧִ
*
*	ڲ	
*
*	ز	0
*
*	˵		
************************************************************
*/
int main(void)
{
	
	Hardware_Init();								//Ӳʼ
	
	//Ӧ
	
	xTaskCreate((TaskFunction_t)IWDG_Task, "IWDG", IWDG_STK_SIZE, NULL, IWDG_TASK_PRIO, (TaskHandle_t*)&IWDG_Task_Handler);
	
	xTaskCreate((TaskFunction_t)USART_Task, "USART", USART_STK_SIZE, NULL, USART_TASK_PRIO, (TaskHandle_t*)&USART_Task_Handler);
	
	xTaskCreate((TaskFunction_t)SEND_Task, "SEND", SEND_STK_SIZE, NULL, SEND_TASK_PRIO, (TaskHandle_t*)&SEND_Task_Handler);
	
	xTaskCreate((TaskFunction_t)SENSOR_Task, "SENSOR", SENSOR_STK_SIZE, NULL, SENSOR_TASK_PRIO, (TaskHandle_t*)&SENSOR_Task_Handler);
	
	xTaskCreate((TaskFunction_t)DATA_Task, "DATA", DATA_STK_SIZE, NULL, DATA_TASK_PRIO, (TaskHandle_t*)&DATA_Task_Handler);
	
	xTaskCreate((TaskFunction_t)UPDATE_Task, "UPDATE", UPDATE_STK_SIZE, NULL, UPDATE_TASK_PRIO, (TaskHandle_t*)&UPDATE_Task_Handler);
	
	xTaskCreate((TaskFunction_t)FAULT_Task, "FAULT", FAULT_STK_SIZE, NULL, FAULT_TASK_PRIO, (TaskHandle_t*)&FAULT_Task_Handler);
	
	xTaskCreate((TaskFunction_t)NET_Task, "NET", NET_STK_SIZE, NULL, NET_TASK_PRIO, (TaskHandle_t*)&NET_Task_Handler);
	
	t1_Thdl = xTimerCreate("Timer1", 200, pdTRUE, (void *)1, (TimerCallbackFunction_t)OS_TimerCallBack);
	xTimerStart(t1_Thdl, 1);
	
	UsartPrintf(USART_DEBUG, "4.OSStart\r\n");		//ʾʼִ
	
	vTaskStartScheduler();							//ʼ
	
	return 0;

}

/*
************************************************************
*	ƣ	IWDG_Task
*
*	ܣ	Ź
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		Ź
************************************************************
*/
void IWDG_Task(void *pvParameters)
{

	while(1)
	{
	
		Iwdg_Feed(); 		//ι
		
		RTOS_TimeDly(200); 	//1s
	
	}

}

/*
************************************************************
*	ƣ	USART_Task
*
*	ܣ	ƽ̨·
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ڽģʽʱȴƽ̨·
************************************************************
*/
void USART_Task(void *pvParameters)
{

	while(1)
	{
		
		OneNET_CmdHandle(data_stream, data_stream_cnt);
		
		RTOS_TimeDly(2);		//10ms
	
	}

}

/*
************************************************************
*	ƣ	SEND_Task
*
*	ܣ	ϴ
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ݷ
************************************************************
*/
void SEND_Task(void *pvParameters)
{
	
	TickType_t pxPreviousWakeTime = 0;
	
	pxPreviousWakeTime = xTaskGetTickCount();
	
	while(1)
	{
		
		onenet_info.send_data = SEND_TYPE_DATA;		//ݷ
		
		vTaskDelayUntil(&pxPreviousWakeTime, 2000);
		
	}

}

/*
************************************************************
*	ƣ	SENSOR_Task
*
*	ܣ	ݲɼʾ
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ݲɼ񡣽Ӵݲɼȡʾ
************************************************************
*/
void SENSOR_Task(void *pvParameters)
{
	
	while(1)
	{
		
//----------------------------ȡź----------------------------------
		if(net_device_info.net_work)
			NET_DEVICE_GetSignal();
		
		RTOS_TimeDly(1000);				//5s
	
	}

}

/*
************************************************************
*	ƣ	DATA_Task
*
*	ܣ	ݷ
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		
************************************************************
*/
void DATA_Task(void *pdata)
{
	
	while(1)
	{

		switch(onenet_info.send_data)
		{
			case SEND_TYPE_DATA:
				
				 onenet_info.send_data = OneNet_SendData(data_stream, data_stream_cnt);	//ϴݵƽ̨

			break;
		}
		
		RTOS_TimeDly(2);											//10ms
	
	}

}

/*
************************************************************
*	ƣ	UPDATE_Task
*
*	ܣ	ά
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		
************************************************************
*/
void UPDATE_Task(void *pvParameters)
{

	while(1)
	{
		
		if(OneNet_Update(30) == 0)
			UsartPrintf(USART_DEBUG, "Update Time Ok\r\n");
		else
			UsartPrintf(USART_DEBUG, "Update Time Err\r\n");
		
		RTOS_TimeDly(4000);						//20s
	
	}

}

/*
************************************************************
*	ƣ	FAULT_Task
*
*	ܣ	״̬
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		ϴ񡣵豸ʱǶӦ־λȻнд
************************************************************
*/
void FAULT_Task(void *pvParameters)
{

	while(1)
	{
		
		if(net_fault_info.net_fault_level != NET_FAULT_LEVEL_0)								//־
		{
			UsartPrintf(USART_DEBUG, "WARN:	NET Fault Process---%d\r\n", net_fault_info.net_fault_level);
			
			NET_Fault_Process();															//
		}
		
		RTOS_TimeDly(10);																	//50ms
	
	}

}

/*
************************************************************
*	ƣ	NET_Task
*
*	ܣ	ӡƽ̨
*
*	ڲ	void͵Ĳָ
*
*	ز	
*
*	˵		񡣻߼״̬д״̬Ȼ
************************************************************
*/
void NET_Task(void *pvParameters)
{
	
	NET_DEVICE_IO_Init();													//豸IOʼ
	
	while(1)
	{
		
		if(!onenet_info.net_work && (net_device_info.device_ok == 1))		//û  ģ⵽ʱ
		{
			if(!NET_DEVICE_Init(data_stream, data_stream_cnt))				//ʼ豸
			{
				if(net_device_info.net_work)
				{
					onenet_info.net_work = 1;
					
					net_fault_info.net_fault_flag = 1;
					
					onenet_info.reinit_count = 0;
				}
			}
		}
		
		if(net_device_info.device_ok == 0) 									//豸δ
		{
			if(!NET_DEVICE_Exist())											//豸
			{
				UsartPrintf(USART_DEBUG, "NET Device :Ok\r\n");
				net_device_info.device_ok = 1;								//⵽豸
			}
			else
			{
				UsartPrintf(USART_DEBUG, "NET Device :Error\r\n");
			}
		}
		
		RTOS_TimeDly(2);													//10ms
	
	}

}
